#!/bin/bash -

pages = ('https://dart.dev/guides/language/effective-dart/style' 'https://dart.dev/guides/language/effective-dart/documentation' 'https://dart.dev/guides/language/effective-dart/usage' 'https://dart.dev/guides/language/effective-dart/design')
build_file_name = 'analysis_options.new.yaml'

# 1. get the web page content
# 2. find all lines with the linter rules we want
# 3. get only links to each rule
# 4. get content of the link (e.g. name of the rule)
# 5. split multiple rules on lines to individual lines
# 6. trim lines
# 7. remove duplicities

for i in "${pages[@]}"
do
    echo "-----"
    curl "$i" | #1
    grep 'Linter rule' | #2
    perl -pe 's/^.*?rules?:\ (.*?)<\/p>/$1/' | #3
    perl -pe 's/<a[^>]*>(.*?)<\/a>/$1/g' | #4
    tr ',' '\n' | #5
    sed 's/^ *//;s/ *$//' | #6
    sort -u #7
done
